<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Admin Management | Dashboard 3</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- IonIcons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<!--
`body` tag options:

  Apply one or more of the following classes to to the body tag
  to get the desired effect

  * sidebar-collapse
  * sidebar-mini
-->

<body class="hold-transition sidebar-mini">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="user.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">User</a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="order.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Admin</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Anh Luong</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Admin
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="user.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Users</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="product.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Products</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="order.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Orders</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">User List</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">User</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <div class="container">
        <div class="text-center mt-3">
          <h2>F120 - Quản trị Users</h2>
        </div>
        <div class="form-group">
          <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
        </div>
      </div>
      <!-- user data table -->
      <div class="container">
        <table id="user-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Id</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
        </table>
      </div>
      <!-- vùng modal -->

      <!-- Create user modal -->
      <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 id="h5-modal-title" class="modal-title">Create new user</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="inp-create-firstname">Firstname</label>
                    <div class="col-sm-8">
                      <input type="text" id="inp-create-firstname" placeholder="Firstname" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="inp-create-lastname">Lastname</label>
                    <div class="col-sm-8">
                      <input type="text" id="inp-create-lastname" placeholder="Lastname" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="select-country">Country</label>
                    <div class="col-sm-8">
                      <select id="select-country" class="form-control">
                        <option value="VN">Việt Nam</option>
                        <option value="USA">USA</option>
                        <option value="AUS">Australia</option>
                        <option value="CAN">Canada</option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="select-customer-type">Customer Type</label>
                    <div class="col-sm-8">
                      <select id="select-customer-type" class="form-control">
                        <option value="Standard">Standard</option>
                        <option value="Gold">Gold</option>
                        <option value="Premium">Premium</option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="inp-create-subject">Subject</label>
                    <div class="col-sm-8">
                      <input type="text" id="inp-create-subject" placeholder="Subject" class="form-control">
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button id="btn-create-user" class="btn btn-primary">Insert User</button>
                <button id="btn-create-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- Update user modal -->
      <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 id="h5-modal-title" class="modal-title">Update User</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="inp-update-firstname">Firstname</label>
                    <div class="col-sm-8">
                      <input type="text" id="inp-update-firstname" placeholder="Firstname" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="inp-update-lastname">Lastname</label>
                    <div class="col-sm-8">
                      <input type="text" id="inp-update-lastname" placeholder="Lastname" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="inp-update-subject">Subject</label>
                    <div class="col-sm-8">
                      <input type="text" id="inp-update-subject" placeholder="Subject" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="select-update-country">Country</label>
                    <div class="col-sm-8">
                      <select id="select-update-country" class="form-control">
                        <option value="VN">Việt Nam</option>
                        <option value="USA">USA</option>
                        <option value="AUS">Australia</option>
                        <option value="CAN">Canada</option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="select-update-customer-type">Customer
                      Type</label>
                    <div class="col-sm-8">
                      <select id="select-update-customer-type" class="form-control">
                        <option value="Standard">Standard</option>
                        <option value="Gold">Gold</option>
                        <option value="Premium">Premium</option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4" for="select-update-register-status">Register
                      Status</label>
                    <div class="col-sm-8">
                      <select id="select-update-register-status" class="form-control">
                        <option value="New">New</option>
                        <option value="Accepted">Accepted</option>
                        <option value="Denied">Denied</option>
                      </select>
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button id="btn-update-user" class="btn btn-primary">Update User</button>
                <button id="btn-update-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- Delete user modal -->
      <div>
        <div class="modal fade" tabindex="-1" id="delete-user-modal">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa user này không?</label>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->

    <!-- Main Footer -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2020-2023 <a href="https://adminlte.io">Devcamp 120</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 2.5.5
      </div>
    </footer>
  </div>
  <!-- ./wrapper -->

  <!-- REQUIRED SCRIPTS -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- AdminLTE -->
  <script src="dist/js/adminlte.js"></script>

  <!-- OPTIONAL SCRIPTS -->
  <script src="plugins/chart.js/Chart.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>
  <!-- AdminLTE dashboard demo (This is only for demo purposes) -->
  <script src="dist/js/pages/dashboard3.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    // biến toàn cục để lưu trữ id user đang dc update or delete. Mặc định = 0
    var gUserId = 0;
    //biến mảng hằng số chứa ds tên các thuộc tính
    const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
    //biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gUSER_FIRSTNAME_COL = 1;
    const gUSER_LASTNAME_COL = 2;
    const gUSER_COUNTRY_COL = 3;
    const gUSER_SUBJECT_COL = 4;
    const gUSER_CUSTOMER_TYPE_COL = 5;
    const gUSER_REGISTER_STATUS_COL = 6;
    const gUSER_ACTION_COL = 7;

    //khai báo DataTable & mapping columns
    var gUserTable = $("#user-table").DataTable({
      columns: [
        { data: gUSER_COLS[gUSER_ID_COL] },
        { data: gUSER_COLS[gUSER_FIRSTNAME_COL] },
        { data: gUSER_COLS[gUSER_LASTNAME_COL] },
        { data: gUSER_COLS[gUSER_COUNTRY_COL] },
        { data: gUSER_COLS[gUSER_SUBJECT_COL] },
        { data: gUSER_COLS[gUSER_CUSTOMER_TYPE_COL] },
        { data: gUSER_COLS[gUSER_REGISTER_STATUS_COL] },
        { data: gUSER_COLS[gUSER_ACTION_COL] }
      ],
      columnDefs: [
        {
          targets: gUSER_ACTION_COL,
          defaultContent: `
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
        }
      ]
    });
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
    });
    //2 - C: gán sự kiện Create-thêm mới user
    $("#btn-add-user").on("click", function () {
      onBtnAddNewUserClick();
    });
    //3 - U: gán sự kiện update-sửa 1 user
    $("#user-table").on("click", ".edit-user", function () {
      onBtnEditUserClick(this);
    });
    //4 - D: gán sự kiện delete-xóa 1 user
    $("#user-table").on("click", ".delete-user", function () {
      onBtnDeleteUserClick(this);
    });

    //gán sự kiện cho nút Create user(trên modal)
    $("#btn-create-user").on("click", function () {
      onBtnCreateUserClick();
    });
    //gán sự kiện cho nút Update user(trên modal)
    $("#btn-update-user").on("click", function () {
      onBtnUpdateUserClick();
    });
    //gán sự kiện cho nút Delete user(trên modal)
    $("#btn-confirm-delete-user").on("click", function () {
      onBtnDeleteUserConfirmClick();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      //1 - R: read/load user to table
      getAllUsers();
    }
    //hàm xử lý sự kiện nút Thêm mới
    function onBtnAddNewUserClick() {
      //hiển thị modal trắng lên
      $("#create-user-modal").modal("show");
    }
    //hàm xử lý sự kiện Update user từ table
    function onBtnEditUserClick(paramEdit) {
      //lưu thông tin userId đang dc edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramEdit);
      console.log("Id của user tương ứng = " + gUserId);
      // load dữ liệu vào các trường dữ liệu trong modal
      getUserDataByUserId(gUserId);
    }
    //hàm xử lý sự kiện Delete user từ table
    function onBtnDeleteUserClick(paramDelete) {
      //lưu thông tin userId đang dc xóa vào biến toàn cục
      gUserId = getUserIdFromButton(paramDelete);
      console.log("Id của user tương ứng = " + gUserId);
      $("#delete-user-modal").modal("show");
    }

    //hàm xử lý sự kiện nút Create user(trên modal)
    function onBtnCreateUserClick() {
      //khai báo obj chứa user data
      var vRequestDataObj = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: ""
      }
      //b1: get data
      getInsertUserData(vRequestDataObj);
      //b2: validate data
      var vIsValid = validateUserData(vRequestDataObj);
      //ghi ra console value trả ra của hàm validateUserData
      console.log(vIsValid);
      if (vIsValid) {
        //b3: insert user
        $.ajax({
          url: gBASE_URL,
          type: "POST",
          contentType: "application/json;charset-UTF-8",
          data: JSON.stringify(vRequestDataObj),
          success: function (paramRes) {
            console.log(paramRes);
            //b4: xử lý front-end
            handleInsertUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }

    //hàm xử lý sự kiện nút Update user(trên modal)
    function onBtnUpdateUserClick() {
      //khai báo obj chứa user data
      var vRequestDataObj = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
        registerStatus: ""
      }
      //b1: get data
      getUpdateUserData(vRequestDataObj);
      //b2: validate data
      var vIsValid = validateUserData(vRequestDataObj);
      if (vIsValid) {
        //b3: update user
        $.ajax({
          url: gBASE_URL + gUserId,
          type: "PUT",
          contentType: "application/json;charset-UTF-8",
          data: JSON.stringify(vRequestDataObj),
          success: function (paramRes) {
            console.log(paramRes);
            //b4: xử lý front-end
            handleUpdateUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }

    // hàm xử lý sự kiện delete voucher modal click
    function onBtnDeleteUserConfirmClick() {
      // B1: Thu thập dữ liệu(k có)
      // B2: Validate delete(k có)
      // B3: call api to delete user
      $.ajax({
        url: gBASE_URL + gUserId,
        type: "DELETE",
        contentType: "application/json;charset-UTF-8",
        success: function (paramRes) {
          // B4: xử lý front-end
          handleDeleteUserSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // load users to DataTable
    // in: users array
    // out: user table has data
    function loadDataToTable(paramUsers) {
      gUserTable.clear();
      gUserTable.rows.add(paramUsers);
      gUserTable.draw();
    }
    //hàm gọi api để lấy all list user đăng ký
    function getAllUsers() {
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function (paramUsers) {
          //ghi response ra console
          console.log(paramUsers);
          loadDataToTable(paramUsers);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    //hàm dựa vào button detail (edit or delete) xác định dc id user
    function getUserIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vUserRowData = gUserTable.row(vTableRow).data();
      return vUserRowData.id;
    }

    //hàm thu thập insert data
    function getInsertUserData(paramUserObj) {
      paramUserObj.firstname = $("#inp-create-firstname").val().trim();
      paramUserObj.lastname = $("#inp-create-lastname").val().trim();
      paramUserObj.country = $("#select-country").val();
      paramUserObj.customerType = $("#select-customer-type").val();
      paramUserObj.subject = $("#inp-create-subject").val().trim();
    }
    //hàm validate data
    function validateUserData(paramUserObj) {
      if (paramUserObj.firstname === "") {
        alert("Firstname is not blank!");
        return false;
      }
      if (paramUserObj.lastname === "") {
        alert("Lastname is not blank!");
        return false;
      }
      if (paramUserObj.subject === "") {
        alert("Subject is not blank!");
        return false;
      }
      return true;
    }
    //hàm xử lý front-end khi thêm user thành công
    function handleInsertUserSuccess() {
      alert("Add new user successfully!");
      getAllUsers();
      resetCreateUserForm();
      $("#create-user-modal").modal("hide");
    }
    //hàm xóa trắng form create user
    function resetCreateUserForm() {
      $("#inp-create-firstname").val("");
      $("#inp-create-lastname").val("");
      $("#select-country").val("VN");
      $("#select-customer-type").val("Standard");
      $("#inp-create-subject").val("");
    }

    //hàm load user data lên update modal form
    function getUserDataByUserId(paramUserId) {
      $.ajax({
        url: gBASE_URL + paramUserId,
        type: "GET",
        success: function (paramUserId) {
          showUserDataToUpdateModal(paramUserId);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
      // hiển thị modal lên
      $("#update-user-modal").modal("show");
    }
    //hàm show user data lên update modal form
    function showUserDataToUpdateModal(paramUserDataObj) {
      $("#inp-update-firstname").val(paramUserDataObj.firstname);
      $("#inp-update-lastname").val(paramUserDataObj.lastname);
      $("#inp-update-subject").val(paramUserDataObj.subject);
      $("#select-update-country").val(paramUserDataObj.country);
      $("#select-update-customer-type").val(paramUserDataObj.customerType);
      $("#select-update-register-status").val(paramUserDataObj.registerStatus);
    }
    //hàm thu thập update data
    function getUpdateUserData(paramUserObj) {
      paramUserObj.firstname = $("#inp-update-firstname").val().trim();
      paramUserObj.lastname = $("#inp-update-lastname").val().trim();
      paramUserObj.subject = $("#inp-update-subject").val().trim();
      paramUserObj.country = $("#select-update-country").val();
      paramUserObj.customerType = $("#select-update-customer-type").val();
      paramUserObj.registerStatus = $("#select-update-register-status").val();
    }
    //hàm xử lý front-end khi update user thành công
    function handleUpdateUserSuccess() {
      alert("Update user successfully!");
      getAllUsers();
      $("#update-user-modal").modal("hide");
    }
    //hàm xử lý front-end khi delete user thành công
    function handleDeleteUserSuccess() {
      alert("Delete user successfully!");
      getAllUsers();
      $("#delete-user-modal").modal("hide");
    }
  </script>
</body>

</html>